; ************************************************************************************************
; * 24-Kanal-LED-Dimmer fr SEDU-Board V2.0													 	 *
; *																								 *
; * empfngt Daten ber Mini-DMX, z.B. von DMXcontrol (96-512 Kanle) in einer ISR				 *
; *	und steuert damit 24 SW-PWM-Kanle															 *
; *	Startadresse einstellbar, alle Daten werden auch ber DMX ausgegeben						 *
; *	Zuordnung von DMX-Kanlen zu C-Pins lsst sich												 *
; * direkt in der Routine "SW_PWM.inc" einstellen												 *				 *
; * nach Reset werden Farben aus der Tabelle "Startup_Colours.inc" gelesen,						 *																								 *
; * diese werden also angezeigt, bevor Daten vom PC kommen (Grundeinstellung)					 *
; *																								 *
; *	by Pesi	- Version 1.0 - 26.12.2011															 *
; ************************************************************************************************

.include "Definitions.inc"					; Definitionen Register, Konstanten etc.

.CSEG

.include "Interrupts.inc"					; IRQ-Vektor-Tabelle

; ================================================================================================
; Subroutinen
; ------------------------------------------------------------------------------------------------

.include "Timer0OVF.inc"					; ISR Timer0 Overflow

.include "USB_Received.inc"					; Byte ber USB empfangen

.include "ISR_Byte_Transmitted.inc"			; mDMX-Besttigung senden

.include "SW_PWM.inc"						; Ausgabe 24 Kanle SW-PWM

.include "Patch_Channels.inc"				; DMX-Kanle zu PWM-Kanlen kopieren

; ================================================================================================
; Programmstart
; ------------------------------------------------------------------------------------------------

_reset:

.include "Configuration.inc"				; Ports setzen, Timer konfigurieren etc.

; ================================================================================================
; Hauptschleife
; ------------------------------------------------------------------------------------------------

_main:

		sbrs	Flags, FL_FRAME_REC			; kompletter Frame empfangen...?
		rjmp	_main						; nein, weiter warten
		cbr		Flags, (1<<FL_FRAME_REC)	; ja, Flag wieder lschen	

		rcall	_Patch_Channels				; und Kanle bertragen

		rjmp	_main						; Hauptschleife von vorne

; ================================================================================================
; Daten im Flash und EEPROM
; ------------------------------------------------------------------------------------------------

 _Bootstring:

.db	"seduboot"								; Startcode fr Bootloader

.include "Startup_Colours.inc"				; Farben nach Reset

.include "DMX_Patchtable.inc"				; Zuordnung DMX-Kanle -> PWM-Kanle

; ================================================================================================
