; ================================================================================================
; Routine vergleicht in einer Empfangs-ISR empfangene Zeichen (befinden sich in temp1)
; mit einer Zeichenkette im Flash (Lnge 1-32 Zeichen)
; Wird als Teil einer blichen _SUB_Byte_Received eingebunden, direkt nach dem Empfang des Bytes
; Variable MDMX_State wird auch als Zhler fr die Zeichenkette benutzt
; wurde der String erkannt, wird der Bootloader aufgerufen
; bei MDMX_State > 31 findet normaler Empfang statt, Routine ist inaktiv
; Vergleich wird nur direkt nach Reset der Empfangsroutine durchgefhrt
;
; Benutzte Register werden nicht gesichert, da diese Routine Teil einer ISR ist,
; in der die Register bereits gesichert werden
;
; DIES NOCH MAL KONTROLLIEREN!
;
; ACHTUNG: Erstes Zeichen des Bootstrings darf nicht der Startcode der Empfangsroutine sein!
; ================================================================================================
; benutzte Register      : temp0, ZL, ZH, werden nicht gesichert!
; gem. benutzte Register : temp1, MDMX_State
; reservierte Register   : keine
;
; Konstanten (zum Kopieren):
;
;.equ BOOTSTRING_LENGHT	= 8				; Lnge Startcode fr Bootloader
;.equ _Bootloader_Start	= 0x7C00		; Startadresse Bootloader im Flash
;
; _Bootstring:
;
;.db	"seduboot"							; Bootstring im Flash
; ------------------------------------------------------------------------------------------------

_Check_Bootstring:

		cpi		MDMX_State, 32					; Check-Modus oder Empfangsmodus..?
		brsh	_SUB_CB_Ende					; Empfangs-Modus, Ende Routine

		ldi		ZL, low(_Bootstring*2)			; Pointer auf Beginn Bootstring setzen
		ldi		ZH, high(_Bootstring*2)

		clr		temp0							; Offset Stringposition addieren
		add		ZL, MDMX_State
		adc		ZH, temp0

		lpm		temp0, Z						; Zeichen holen

		cp		temp0, temp1					; mit empfangenem Zeichen vergleichen

		brne	_SUB_CB_Clear					; falsches Zeichen empfangen, Receiver Reset

		inc		MDMX_State						; passendes Zeichen empfangen, weiter zhlen

		cpi		MDMX_State, BOOTSTRING_LENGHT	; kompletter String erfolgreich verglichen...?

		brlo	_SUB_CB_Ende					; nein, beim nchsten Aufruf weiter vergleichen

		jmp		_Bootloader_Start				; ja, Bootloader starten

_SUB_CB_Clear:

		clr		MDMX_State

_SUB_CB_Ende:
		
; ================================================================================================
