; ================================================================================================
; 24-Kanal-PWM mit Mini-DMX-Empfang fr SEDU-Board V2.0
; Konfigurationen
; ================================================================================================

; ================================================================================================
; Ports I/O setzen etc.
; ------------------------------------------------------------------------------------------------

		sbi		S_LED_DDR, S_LED				; Port fr Status-LED auf Ausgang
		cbi		S_LED_Port, S_LED				; Status-LED an

		sbi		DMX_DDR, DMX_DIR				; Pin fr RS485-Treiber Umschaltung
		sbi		DMX_PORT, DMX_DIR				; RS485-Treiber auf senden
		sbi		DMX_DDR, DMX_TX					; TX-Pin auf Ausgang
		cbi		DMX_PORT, DMX_TX				; Tx-Pin auf Low fr Break

		ser		temp0							; PWM-Ports auf Ausgang
		out		DDRA, temp0
		out		DDRB, temp0
		out		DDRC, temp0

; ================================================================================================
; Stackpointer setzen
; ------------------------------------------------------------------------------------------------

		ldi 	temp0, HIGH(RAMEND)				; HIGH-Byte der obersten RAM-Adresse
		out 	SPH, temp0						; in den Stackpointer
		ldi 	temp0, LOW(RAMEND)				; LOW-Byte der obersten RAM-Adresse
		out 	SPL, temp0						; in den Stackpointer

; ================================================================================================
; USART0 konfigurieren fr USB-Bridge
; ------------------------------------------------------------------------------------------------

.equ UBRR_USB =((XTAL+BAUD_USB*8)/(BAUD_USB*16)-1)  	; UBBR ausrechnen

	   	ldi 	temp0, UBRR_USB				 	; Usart auf Baudrate USB-Bridge setzen
    	sts 	UBRR0L, temp0
    	clr 	temp0
    	sts 	UBRR0H, temp0

    	ldi 	temp0, (3<<UCSZ00)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR0C, temp0			

		ldi		temp0, (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0)|(1<<TXCIE0) ; Rx, Tx, Rx/TxComplInt. en.
		sts		UCSR0B, temp0

		clr		mDMX_State						; Status: auf Startbyte warten

; ================================================================================================
; USART1 konfigurieren fr DMX_Ausgabe
; ------------------------------------------------------------------------------------------------

.equ UBRR_DMX =((XTAL+BAUD_DMX*8)/(BAUD_DMX*16)-1)  	; UBBR ausrechnen

	   	ldi 	temp0, UBRR_DMX				 	; Usart auf Baudrate DMX setzen
    	sts 	UBRR1L, temp0
    	clr 	temp0
    	sts 	UBRR1H, temp0

    	ldi 	temp0, (3<<UCSZ10)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR1C, temp0			

		ldi		temp0, (1<<TXEN1)			 	; Tx enable
		sts		UCSR1B, temp0

; ================================================================================================
; Timer 0 konfigurieren fr SW-PWM und Zeitbasis
; ------------------------------------------------------------------------------------------------

		ldi     temp0, (1<<CS00)	   			; Normal Mode, Prescaler auf 1, Timer starten
		out		TCCR0B, temp0

		ldi     temp0, (1<<TOIE0)      			; TOIE0: Interrupt bei Timer0 Overflow
		sts     TIMSK0, temp0

; ================================================================================================
; Standalone-Farben nach Reset, Startwerte
; ------------------------------------------------------------------------------------------------

		clr		Flags							; Flags lschen

		ser		Timebase						; Timeout resetten

		ldi		ZH, high(STARTUP_COLOURS*2)		; Zeiger auf Farbtabelle Startup setzen
		ldi		ZL, low(STARTUP_COLOURS*2)

		ldi		YH, high(PWM_BUFFER)			; Zeiger auf Start-Position Daten im RAM setzen
		ldi		YL, low(PWM_BUFFER)

		ldi		temp0, 24						; 24 Kanle in's RAM bertragen

_Set_Startup_Colours_Loop:

		lpm		temp1, Z+						; Byte aus dem Flash holen
		st		Y+, temp1						; und in's RAM speichern

		dec		temp0							; alle Kanle durch?
		brne	_Set_Startup_Colours_Loop		; nein, weiter

; ================================================================================================

		sei										; Interrupts aktivieren

; ================================================================================================
