; ================================================================================================
; 24-Kanal-PWM mit Mini-DMX-Empfang fr SEDU-Board V2.0
; Definitionen Register, Konstanten, etc.
; ================================================================================================

.include "m644Pdef.inc"						; verwendeter C: Mega644p

; ================================================================================================
; Register definieren
; ------------------------------------------------------------------------------------------------

.def temp0 				= R16				; (>15) Mehrzweck-Temp-Register	
.def temp1 				= R17
.def temp2 				= R18
.def temp3				= R19

.def mDMX_State			= R20				; (>15) Status mDMX-Empfangsroutine
.def tx_State			= R4				; Status Transmitter
.def MDMX_Framecount_L	= R21				; (>15) Zhler fr empfangene Bytes L
.def MDMX_Framecount_H	= R22				; (>15) Zhler fr empfangene Bytes H
.def MDMX_Buffer_L		= R2				; Zeiger auf Empfangspuffer L
.def MDMX_Buffer_H		= R3				; Zeiger auf Empfangspuffer H

.def Timebase 			= R23				; (>15) Zhler fr Timeout etc.

.def pwm_count 			= R24				; (>15) Zhler fr PWM

.def Flags				= R25				; (>15) Div. Flags

; ================================================================================================
; RAM-Bereiche definieren
; ------------------------------------------------------------------------------------------------

.equ MDMX_BUFFER		= 0x0160			; RAM-Puffer fr empfangene mDMX-Daten

.equ PWM_BUFFER			= 0x0100			; RAM-Puffer fr PWM-Ausgabedaten

; ================================================================================================
; Konstanten/Aliase definieren
; ------------------------------------------------------------------------------------------------

.equ XTAL				= 20000000			; Prozessortakt 20 MHz Quarz

.equ BAUD_USB			= 250000			; Baudrate USB

.equ BAUD_DMX			= 250000			; Baudrate DMX

.equ S_LED				= 5					; Pin Status-LED
.equ S_LED_Port			= PortD				; Port Status-LED
.equ S_LED_DDR			= DDRD				; DDR Status-LED

.equ DMX_PORT			= PortD				; Port fr DMX
.equ DMX_DDR			= DDRD				; DDRD dazu
.equ DMX_TX				= 3					; Pin fr DMX Tx
.equ DMX_DIR			= 6					; RS485-Treiber Senden/empfangen

.equ BOOTSTRING_LENGHT	= 8					; Lnge Startcode fr Bootloader
.equ _Bootloader_Start	= 0x7C00			; Startadresse Bootloader im Flash


.equ PWM_CHANNELS		= 24				; Anzahl PWM-Kanle

.equ FL_FRAME_REC		= 0					; kompletter Frame empfangen

; ================================================================================================
