; ================================================================================================
; Besttigung fr Mini-DMX-Empfang senden
;
; gehrt zu _ISR_Byte_Received.inc, wird dort angestoen
; ================================================================================================
; benutzte Register      : temp1, wird gesichert
; gem. benutzte Register : rx_State
; reservierte Register   : keine
;
; Definitionen (zum Kopieren):
;
;.def tx_State			= R4				; Status Transmitter
; ------------------------------------------------------------------------------------------------

_ISR_Byte_Transmitted:

		push	temp1							; Register sichern
		in		temp1, SREG
		push	temp1

		mov 	temp1, tx_State					; Status holen

		cpi		temp1, 1						; 1= C1 versenden
		brne	_ISR_TX_2						; anderer Wert
		ldi		temp1, 0xC1						; richtiger Wert, C1...
		sts		UDR0, temp1						; ...versenden
		ldi		temp1, 2						; nchster Aufruf: A5 versenden
		mov		tx_State, temp1					; speichern
		rjmp	_ISR_TX_Ende					; und raus

_ISR_TX_2:

		cpi		temp1, 2						; 2= A5 versenden
		brne	_ISR_TX_Clear					; anderer Wert, rx_State zurck setzen
		ldi		temp1, 0xA5						; richtiger Wert, A5...
		sts		UDR0, temp1						; ...versenden

_ISR_TX_Clear:

		clr		temp1							; nchster Aufruf: nichts versenden
		mov		tx_State, temp1					; speichern

_ISR_TX_Ende:

		pop		temp1							; Register wiederherstellen
		out		SREG, temp1
		pop		temp1

		reti									; Ende Routine

; ================================================================================================
