; ================================================================================================
; 24-Kanal-PWM mit Mini-DMX-Empfang fr SEDU-Board V2.0
; Kopieren der per (m)DMX empfangenen Daten in den PWM-Buffer
; dabei werden die Kanle lt. "DMX_Patchtable.inc" umsortiert
; ================================================================================================
; benutzte Register      : temp0, temp1, temp2, YL, YH, ZL, ZH, werden gesichert
; gem. benutzte Register : keine
; reservierte Register   : siehe Definitionen
;
; Definitionen (zum Kopieren):
; 
;.equ PWM_CHANNELS		= 24				; Anzahl PWM-Kanle
; ------------------------------------------------------------------------------------------------

_Patch_Channels:

		push	temp0							; Register sichern
		push	temp1
		push	temp2
		push	YL
		push	YH
		push	ZL
		push	ZH

		ldi		YL, low(PWM_BUFFER)				; Y auf PWM-Puffer
		ldi		YH, high(PWM_BUFFER)

		ldi		ZL, low(DMX_PATCHTABLE*2)		; Z auf Patchtabelle
		ldi		ZH, high(DMX_PATCHTABLE*2)

		ldi		temp0, PWM_CHANNELS				; Zahl der zu bertragenden Kanle

_pc_copy_loop:

		lpm		temp1, Z+						; Kanalnummer holen
		lpm		temp2, Z+

		push	ZL								; Z-Pointer sichern
		push	ZH

		ldi		ZL, low(MDMX_BUFFER-1)			; Z auf Eingangspuffer
		ldi		ZH, high(MDMX_BUFFER-1)

		add		ZL, temp1						; Kanalnummer addieren
		adc		ZH, temp2

		ld		temp1, Z						; empfangenes Byte holen
		st		Y+, temp1						; und in den PWM-Buffer schreiben

		pop		ZH								; Z-Pointer wieder holen
		pop		ZL

		dec		temp0
		brne	_pc_copy_loop

		pop		ZH								; Register wiederherstellen
		pop		ZL
		pop		YH
		pop		YL
		pop		temp2
		pop		temp1
		pop		temp0

		ret										; Ende Routine

; ================================================================================================
